﻿Param(
$RootFolder = "C:\Program Files"
)

$Items = (Get-ChildItem -Path $RootFolder -ErrorAction "SilentlyContinue" -Force | Where-Object {$_.GetType().Name -eq "FileInfo"} | Measure-Object -Property Length -Sum)
[Array]$Folders = [PSCustomObject]@{
    "Fullname" = $RootFolder
    "Size(MB)" = ("{0:N1}" -F ($Items.Sum / 1MB))
    }

$Items = (Get-ChildItem -Path $RootFolder -ErrorAction "SilentlyContinue" -Recurse | Where-Object {$_.GetType().Name -eq "DirectoryInfo"})
$Folders += ForEach ($i in $Items)
{
    $SubFolderItems = (Get-ChildItem -Path $i.FullName -ErrorAction "SilentlyContinue" -Force | Where-Object {$_.GetType().Name -eq "FileInfo"} | Measure-Object -Property Length -Sum)

    [PSCustomObject]@{
    "Fullname" = $i.FullName
    "Size(MB)" = [decimal]("{0:N1}" -F ($SubFolderItems.Sum / 1MB))
    }
}

$Folders | Sort "Size(MB)" -Descending  | Select-Object -First 20 | Format-Table -AutoSize
